import{SmartRenderer}from'../../../../fc-core/src/component-interface';import{utcMillisecond,utcSecond,utcMinute,utcHour,utcDay,utcWeek,utcMonth,utcYear}from'../../../../fc-utils/src/time-intervals/utc';import{timeMillisecond,timeSecond,timeMinute,timeHour,timeDay,timeWeek,timeMonth,timeYear}from'../../../../fc-utils/src/time-intervals';import{pluckNumber,pluck,BLANKSTRING,extend2,parseUnsafeString,DEFAULT_FT_FONT}from'../../../../fc-core/src/lib';import TimeConverter from'../../../../fc-utils/src/time-converter';const GUTTER_2=2,GUTTER_5=5,GUTTER_8=8,GUTTER_14=14,COLOR_858585='#858585',COLOR_5F5F5F='#5f5f5f';function isValidUnit(a){return!('year'!==a&&'quarter'!==a&&'month'!==a&&'week'!==a&&'day'!==a&&'hour'!==a&&'minute'!==a&&'second'!==a&&'millisecond'!==a)}function getInterVal(a,b){return'year'===a?b?utcYear:timeYear:'quarter'===a?b?utcMonth:timeMonth:'month'===a?b?utcMonth:timeMonth:'week'===a?b?utcWeek:timeWeek:'day'===a?b?utcDay:timeDay:'hour'===a?b?utcHour:timeHour:'minute'===a?b?utcMinute:timeMinute:'second'===a?b?utcSecond:timeSecond:'millisecond'===a?b?utcMillisecond:timeMillisecond:void 0}function isWithinMarker(a,b,c,d){let e,f,g,h,j=!1,k=d.markerDim,l=a.getLinkedParent().config,m=l.padding,n=m.left,o=m.right,p=m.top,q=m.bottom;for(b+=o-n,c+=q-p,(g=0,h=k.length);g<h;g++)if(b>=k[g].x&&b<=k[g].x+k[g].width&&c>=k[g].y&&c<=k[g].y+k[g].height){j=!0,a.config.previouslyHoveredIndex=d.index,e=k[g];break}return f={pointIndex:d.index,hovered:j,pointObj:{hoveredMarkerDim:e,index:j&&g},previouslyHoveredIndex:a.config.previouslyHoveredIndex,component:a},f}class TimeSpanMarker extends SmartRenderer{__setDefaultConfig(){super.__setDefaultConfig(),this.config.defaultStyle={text:{fill:'#808080',"font-family":DEFAULT_FT_FONT,"font-size":'10px',"font-weight":'normal',"font-style":'normal',"vertical-align":'bottom',"text-anchor":'middle'},marker:{fill:'#62b58f',opacity:.2,"border-thickness":0,"border-padding":1,"border-radius":0,"border-dash":'none',"stroke-width":'1'}},this.config.toolTipOpacity=.9,this.config.hoveredIndex=void 0,this.config.previouslyHoveredIndex=void 0,this.config.hoveredOpacity=.5,this.config.valueArr=[],this.config.textArr=[],this.config.styleArr=[],this.config.domainArr=[],this.config.markerDetails=[]}getHoveredMarker(a,b){let c,d,e=this,f=e.config,g=e.getLinkedParent(),h=g.getTranslation(),j=f.markerDetails;for(a-=h.x,b-=h.y,d=j.length-1;0<=d&&(c=isWithinMarker(e,a,b,j[d]),!c.hovered);d--);return c}setHoverInEffect(a){let b=this,c=b.getFromEnv('chart');b.setData({hoveredIndex:a},!0),c.fireEvent('timeSpanMarkerHovered',{senderTimeMarker:b,hoveredIndex:a,hoveredFromOutside:!0})}setHoverOutEffect(){let a=this,b=a.getFromEnv('chart');a.setData({hoveredIndex:void 0},!0),b.fireEvent('timeSpanMarkerHovered',{senderTimeMarker:a,hoveredIndex:void 0,hoveredFromOutside:!0})}getToolTextConfiguration(a){let b,c=this,d=c.config.toolTipOpacity,e=40,f=26,g=c.getFromEnv('smartLabel');return g.setStyle({"font-size":'12px',"font-family":DEFAULT_FT_FONT,"font-weight":'600'}),b=g.getSmartText(a[0]),e+=b.width,f+=b.height,a[1]?(g.setStyle({"font-size":'11px',"font-family":DEFAULT_FT_FONT,"font-weight":'normal'}),b=g.getSmartText(a[1]),f+=b.height,e=Math.max(e,b.width),{toolText:`<div style='opacity:${d}; text-align:center'>
                  <div style='font-weight: 600; margin: 5px;font-size: 12px; color:${COLOR_858585}'>${a[0]}</div>
                  <div style='font-size: 11px;margin: 5px;color:${COLOR_5F5F5F}'>${a[1]}</div>
                  </div>`,dimensions:{width:e,height:f}}):{toolText:`<div style='opacity:${d}; text-align:center; padding: 5px;'>
                <div style= 'font-weight: 600; font-size: 12px; color:${COLOR_858585}'>${a[0]}</div>
                </div>`,dimensions:{width:e,height:f}}}getMarkerAndLabelConfiguration(a,b){let c,d,e,f,g,h,i,j=this,k=j.config,l=j.getLinkedParent().config,m=l.padding,n=m.left,o=m.right,p=m.top,q=m.bottom,r=j.config.xScale,s=r.getDomain(),t=k.valueArr[a],u=t.repeat;return c=r.getRangeValue(t.start),i=r.getRangeValue(t.end),e=l.canvasTop+l.canvasHeight-GUTTER_2-p+q,k.markerDetails[a].markerDim=[],k.domainArr[a]=[],k.markerDetails[a].index=a,!u&&+t.start>=+s[0]&&+t.end<=+s[1]?(k.domainArr[a].push({start:t.start,end:t.end}),k.markerDetails[a].markerDim.push({x:c-n+o,y:l.canvasTop+l.canvasHeight-(b+4)-p+q,width:i-c,height:b+4}),d=c-n+o,g=t.start,h=t.end):u&&(k.domainArr[a]=f=j.getAllValidDomains(t.start,t.end,t.repeat),f.length&&(d=r.getRangeValue(f[0].start)-n+o,g=f[0].start,h=f[0].end,f.forEach(e=>{c=r.getRangeValue(e.start),i=r.getRangeValue(e.end),k.markerDetails[a].markerDim.push({x:c-n+o,y:l.canvasTop+l.canvasHeight-(b+4)-p+q,width:i-c,height:b+4}),0>u.multiplier&&(d=c-n+o,g=e.start,h=e.end)}))),{labelConfiguration:{x:d,y:e,width:i-c-4,startDomain:g,endDomain:h}}}getAllValidDomains(a,b,c){let d=this,e=d.config.xScale,f=e.getDomain(),g=[];if(+a<+f[0]&&0<c.multiplier)for(;+a<+f[0];)a=c.interval.offset(a,c.multiplier),b=c.interval.offset(b,c.multiplier);for(;+a>=+f[0]&&+b<=+f[1];)g.push({start:a,end:b}),a=c.interval.offset(a,c.multiplier),b=c.interval.offset(b,c.multiplier);return g}configureAttributes(a={}){super.configureAttributes(a);let b,c,d,e,f,g,h,j,k=this,l=k.config,m=[],n=[],o=k.getFromEnv('isUTC'),p=[],q=k.getFromEnv('getStyleDef'),r=a.timeMarker||[];for(h=0,j=r.length;h<j;h++)r[h].start&&r[h].start!==BLANKSTRING&&(e=pluck(r[h].timeformat,a.defaultFormat),c=o?TimeConverter.utcParser(e):TimeConverter.parser(e),d=c.parse(r[h].start),f=c.parse(r[h].end),d&&f)&&(+d>+f&&([d,f]=[f,d]),b={start:d,end:f,startString:r[h].start,endString:r[h].end,timeFormat:e},r[h].repeat&&r[h].repeat.unit&&0!==Math.floor(+r[h].repeat.multiplier)&&isValidUnit(g=r[h].repeat.unit.toLowerCase())&&(b.repeat={interval:getInterVal(g,o),multiplier:('quarter'===g?3:1)*pluckNumber(r[h].repeat.multiplier,1)}),p.push(b),m.push(q(r[h].style)),n.push(pluck(r[h].label,'')));a.xScale&&(l.xScale=a.xScale),l.hoveredIndex=a.hoveredIndex,a.timeMarker&&(l.valueArr=p,l.styleArr=m,l.textArr=n)}getAllLabelsProps(a,b){let c,d,e,f,g,h,j,k,l,m=this,n=m.config,o=m.getFromEnv('smartLabel'),p=n.valueArr,q=n.domainArr[a],r=n.markerDetails[a],s=m.getFromEnv('isUTC'),t=b.x,u=b.y,v=b.width,w=o._lineHeight,x=[],y=n.textArr[a];for(y&&(f=o.getSmartText(parseUnsafeString(y),v,w),x.push({dim:{x:t+v/2+GUTTER_2,y:u-GUTTER_2},text:parseUnsafeString(f.text)})),d=p[a].timeFormat,(k=0,l=q.length);k<l;k++)j=[],c=q[k],e=r.markerDim[k],h=s?TimeConverter.utcFormatter(d):TimeConverter.formatter(d),g=h.format(c.start)+' - '+h.format(c.end),j.push(g),y&&j.push(f.oriText),e.toolTextArr=j;return x}drawAllLabels(a,b){let c=this;a.forEach((a,d)=>{c.addGraphicalElement({el:'text',attr:{text:a.text,x:a.dim.x,y:a.dim.y,"font-family":b.text['font-family'],"font-weight":b.text['font-weight'],"font-style":b.text['font-style'],"font-size":b.text['font-size'],fill:b.text.fill,"text-anchor":b.text['text-anchor'],"vertical-align":b.text['vertical-align']},container:{label:'timeMarker'},id:'time-marker-label-'+d,component:c,label:'label'})})}draw(){let a,b,c,d,e,f,g,h,k=this,l=k.config,m=l.valueArr,n=k.getFromEnv('smartLabel'),o=k.getFromEnv('textStyle'),p=l.defaultStyle,q=l.styleArr;for(k.addGraphicalElement({el:'group',container:{id:'thermo',label:'group',isParent:!0},component:k,label:'timeMarker',attr:{name:'time-marker-group'},id:'timeMarker'}),l.markerDetails=[],(f=0,h=m.length);f<h;f++)if(l.markerDetails[f]={},a=extend2(extend2(extend2({},{text:o}),p),q[f]),n.setStyle({"font-size":a.text['font-size'],"font-family":a.text['font-family'],"font-weight":a.text['font-weight']}),c=k.getMarkerAndLabelConfiguration(f,n._lineHeight),d=l.markerDetails[f].markerDim,e=c.labelConfiguration,d.length){for(b=k.getAllLabelsProps(f,e,a),g=0;g<d.length;g++)k.addGraphicalElement({el:'rect',attr:{x:d[g].x,y:d[g].y,width:d[g].width,height:d[g].height,stroke:'none',fill:a.marker.fill,opacity:l.markerDetails[f].index===l.hoveredIndex?l.hoveredOpacity:a.marker.opacity},container:{label:'timeMarker'},id:'time-span-marker-'+f+g,component:k,label:'line'});k.drawAllLabels(b,a)}}getType(){return'timeMarker'}getName(){return'timeSpanMarker'}}export default TimeSpanMarker;